package tech.riemann.ims.dto.response;

import org.nutz.dao.entity.annotation.Column;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.media.Schema.RequiredMode;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.FieldNameConstants;
import lombok.experimental.SuperBuilder;
import tech.riemann.ims.entity.acl.Role;

/**
 * @author Kerbores(kerbores@gmail.com)
 *
 */
@Data
@EqualsAndHashCode(callSuper = true)
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@FieldNameConstants
@TableName(autoResultMap = true)
@Schema(name = "RoleInfo", description = "角色信息,包含是否选中标识")
public class RoleInfo extends Role {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    @Schema(description = "角色是否选中标识", requiredMode = RequiredMode.REQUIRED)
    @Column("selected")
    @TableField("selected")
    boolean selected;

}
