package tech.riemann.ims.dto.response;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * @author mayong
 * @since 2025/1/18 19:20
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class TypeTree {
    @Schema(description = "类型编码", requiredMode = Schema.RequiredMode.REQUIRED)
    private String value;
    @Schema(description = "类型名称", requiredMode = Schema.RequiredMode.REQUIRED)
    private String label;
    private String parentNo;
    private List<TypeTree> children;


    public static List<TypeTree> buildTree(List<TypeTree> data, String root) {
        return data.stream()
                .filter(t -> Objects.equals(t.getParentNo(), root))
                .peek(t -> t.setChildren(buildTree(data, t.getValue()))).
                collect(Collectors.toList());
    }
}
