package tech.riemann.ims.entity.dictionary;

import org.nutz.dao.entity.annotation.ColDefine;
import org.nutz.dao.entity.annotation.Column;
import org.nutz.dao.entity.annotation.Comment;
import org.nutz.dao.entity.annotation.Table;
import org.nutz.lang.random.R;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.media.Schema.RequiredMode;
import lombok.AllArgsConstructor;
import lombok.Builder.Default;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import lombok.experimental.FieldNameConstants;
import lombok.experimental.SuperBuilder;
import tech.riemann.ims.entity.IdBaseEntity;

import java.io.Serial;

/**
 * 码本分组
 *
 * @author Kerbores(kerbores@gmail.com)
 *
 * @since 2024-07-22 13:56:55
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@FieldNameConstants
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("t_group")
@Table("t_group")
@Comment("码本分组")
@Schema(name = "Group", description = "码本分组")
public class Group extends IdBaseEntity {

    @Serial
    private static final long serialVersionUID = 1L;

    @Schema(description = "分组唯一键", requiredMode = RequiredMode.REQUIRED)
    @TableField("g_key")
    @Column("g_key")
    @Comment("分组唯一键")
    @ColDefine(notNull = true, width = 128, precision = 0)
    @Default
    private String key = R.UU16();

    @Schema(description = "分组名称", requiredMode = RequiredMode.NOT_REQUIRED)
    @TableField("g_name")
    @Column("g_name")
    @Comment("分组名称")
    @ColDefine(notNull = false, width = 128, precision = 0)
    private String name;

    @Schema(description = "分组描述", requiredMode = RequiredMode.NOT_REQUIRED)
    @TableField("g_description")
    @Column("g_description")
    @Comment("分组描述")
    @ColDefine(notNull = false, width = 128, precision = 0)
    private String description;

    @Schema(description = "禁用标识", requiredMode = RequiredMode.NOT_REQUIRED)
    @TableField("g_disabled")
    @Column("g_disabled")
    @Comment("禁用标识")
    @ColDefine(notNull = false, width = 1, precision = 0)
    private Boolean disabled;
}
