package tech.riemann.ims.service.material.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.RequiredArgsConstructor;
import org.nutz.dao.Dao;
import org.springframework.stereotype.Service;
import tech.riemann.ims.dto.response.ApplyDTO;
import tech.riemann.ims.entity.material.ApplyForm;
import tech.riemann.ims.mapper.material.ApplyFormMapper;
import tech.riemann.ims.service.material.IApplyFormService;

/**
 * @author mayong
 * @since 2024/11/28 15:36
 */
@Service
@RequiredArgsConstructor
public class ApplyFormServiceImpl extends ServiceImpl<ApplyFormMapper, ApplyForm> implements IApplyFormService {

    private final ApplyFormMapper applyFormMapper;
    private final Dao dao;

    @Override
    public Dao dao() {
        return dao;
    }

    @Override
    public IPage<ApplyDTO> search(int page, int size, Integer applyType, String type, String code, String name) {
        return applyFormMapper.searchPage(Page.of(page, size), applyType, type, code, name);
    }
}
